<?php

ini_set('display_errors', 1);
// error_reporting(0);

//require_once '../../resources/base_path_include.php';
require_once '../../../resources/base_path_include.php';
// should we not call header and ch
require_once $base_path_to_resources . "includes/config.php"; // use require for mandatory files
//require($base_path_to_resources."/lib/function.php");
require_once $base_path_to_resources . 'lib/function.php';

require_once  $base_path_to_resources . 'includes/config.php';
require_once  $base_path_to_resources . 'lib/function.php';
require_once $base_path_to_resources . "lib/currency_functions.php";

//valdation file
require_once $base_path_to_resources . 'lib/validate_api_signature.php';
require_once $base_path_to_resources . 'lib/validate_function.php';
require_once $base_path . 'user_management/authenticate.php';
//creating dynamic db
require_once $base_path_to_resources . 'includes/specific_db_config.php';

$postdata = json_decode(file_get_contents("php://input"), true);
checkIfNoPhpContentsReceive();
validateApiSignature($postdata['api_signature']);
//authenticate jwt token
$jwttoken = $postdata['jwt_token'];
$jwt_validate = authenticate_jwt($jwttoken);
//then workspace_id is decoded in data of jwt use from there
$userid = $jwt_validate->data->id;
$workspace_id = $jwt_validate->data->workspace_id;
$role = $jwt_validate->data->role;
$created_by = $jwt_validate->data->username;

$confirmed_role_user = validatePrimaryAccess($conn, $workspace_id, $role, $userid, ['superadmin', 'admin', null]);
if (!$confirmed_role_user){ 
        errorreturn('Access denied.');
}else{
        $specific_db_conn = dynamicDbConnection($confirmed_role_user);
        //  if ($role == null) {
        //     checkCompanyBranchFunctionAccess($specific_db_conn, $role, $userid, $workspace_id, null, null, null,  $function_code);
        //  }
}

if ($postdata['function_type']  == "display_denoniminations") {

    $company_id = trim($postdata['company_id']);
    $branch_id = trim($postdata['branch_id']);

    $sql = $specific_db_conn->prepare("SELECT base_currency_formal_name FROM  branch_info WHERE  workspace_id = ? and company_id =? and id =?");
    $sql->execute(array($workspace_id, $company_id, $branch_id));
    $result = $sql->fetchAll();
    if (count($result) == 1) {

        $base_currency_formal_name = $result[0]['base_currency_formal_name'];
        $success['denominations'] = currency_denoniminations($base_currency_formal_name);
        successreturn($success);
    } else {

        errorreturn("Currency Symbol Not Exists in Branch Info.");
    }
}
